
package edu.uwec.cs.wickmr.life.state;

import java.util.*;

public class GameOfLife {
	protected int ROWS;
	protected int COLS;
	protected Cell grid[][];
	protected List observers; // Holds access to all observers
	
	public GameOfLife(int rows, int cols){
		this.ROWS = rows;
		this.COLS = cols;
		grid = new Cell[rows][cols];
		observers = new LinkedList();
		clearGrid(grid);
	}
	protected void clearGrid(Cell[][] g){
		for(int i =0; i < ROWS; i++){
			for(int j=0; j < COLS; j++){
				g[i][j] = new Cell(i,j);
			}
		}
	}
	public int getRows(){
		return ROWS;
	}
	public int getCols(){
		return COLS;
	}
	public boolean isAlive(int r, int c){
		return grid[r][c].isAlive();
	}
	public Cell cellAt(int r, int c){
		return grid[r][c];
	}
	public void toggle(int r, int c){
		grid[r][c].toggle();
		notifyObservers();
	}
	public void advance(){
		// TODO: B5 - Modify the advance() method in the GameOfLife class.
		// Instructions:
		//   1. Replace the "Make cell in newGrid alive" comments with a call
		//         to "newGrid[i][j].live()"
		Cell[][] newGrid = new Cell[ROWS][COLS];
		clearGrid(newGrid); // Sets all grid locations to dead cells by default.
		int n =0;
		for(int i = 0; i < ROWS; i++){
			for(int j = 0; j < COLS; j++){
				n = grid[i][j].nbrOfNeighbors(this);
				if ( grid[i][j].isAlive() ){
					if ( n == 2 || n == 3 ){
						// Make cell in newGrid alive
					}
				}
				else {
					if ( n == 3){
						// Make cell in newGrid alive
					}
				}
				
			}
		}
		grid = newGrid;
		notifyObservers();
	}
	// Add the given GameOfLifeUI to the list of observers.
	public void attach(GameOfLifeUI userInterface){
		observers.add(userInterface);
	}
	
	// Remove the given GameOfLifeUI from the list of observers.
	public void detach(GameOfLifeUI userInterface){
		observers.remove(userInterface);
	}
	
	// Inform all observers to update.
	public void notifyObservers(){
		Iterator uiItr = observers.iterator();
		while (uiItr.hasNext()){
			((GameOfLifeUI)uiItr.next()).update();
		}
	}
}
